// SCSS variables are information about icon's compiled state, stored under its original file name
//
// .icon-home {
//   width: $icon-home-width;
// }
//
// The large array-like variables contain all information about a single icon
// $icon-home: x y offset_x offset_y width height total_width total_height image_path;
//
// At the bottom of this section, we provide information about the spritesheet itself
// $spritesheet: width height image $spritesheet-sprites;
$icon-card-name: 'icon-card';
$icon-card-x: 0px;
$icon-card-y: 0px;
$icon-card-offset-x: 0px;
$icon-card-offset-y: 0px;
$icon-card-width: 20px;
$icon-card-height: 15px;
$icon-card-total-width: 40px;
$icon-card-total-height: 31px;
$icon-card-image: '../img/sprite.png';
$icon-card: (0px, 0px, 0px, 0px, 20px, 15px, 40px, 31px, '../img/sprite.png', 'icon-card', );
$icon-cvv-name: 'icon-cvv';
$icon-cvv-x: 20px;
$icon-cvv-y: 15px;
$icon-cvv-offset-x: -20px;
$icon-cvv-offset-y: -15px;
$icon-cvv-width: 20px;
$icon-cvv-height: 16px;
$icon-cvv-total-width: 40px;
$icon-cvv-total-height: 31px;
$icon-cvv-image: '../img/sprite.png';
$icon-cvv: (20px, 15px, -20px, -15px, 20px, 16px, 40px, 31px, '../img/sprite.png', 'icon-cvv', );
$spritesheet-width: 40px;
$spritesheet-height: 31px;
$spritesheet-image: '../img/sprite.png';
$spritesheet-sprites: ($icon-card, $icon-cvv, );
$spritesheet: (40px, 31px, '../img/sprite.png', $spritesheet-sprites, );

// The provided mixins are intended to be used with the array-like variables
//
// .icon-home {
//   @include sprite-width($icon-home);
// }
//
// .icon-email {
//   @include sprite($icon-email);
// }
//
// Example usage in HTML:
//
// `display: block` sprite:
// <div class="icon-home"></div>
//
// To change `display` (e.g. `display: inline-block;`), we suggest using a common CSS class:
//
// // CSS
// .icon {
//   display: inline-block;
// }
//
// // HTML
// <i class="icon icon-home"></i>
@mixin sprite-width($sprite) {
  width: nth($sprite, 5);
}

@mixin sprite-height($sprite) {
  height: nth($sprite, 6);
}

@mixin sprite-position($sprite) {
  $sprite-offset-x: nth($sprite, 3);
  $sprite-offset-y: nth($sprite, 4);
  background-position: $sprite-offset-x  $sprite-offset-y;
}

@mixin sprite-image($sprite) {
  $sprite-image: nth($sprite, 9);
  background-image: url(#{$sprite-image});
}

@mixin sprite($sprite) {
  @include sprite-image($sprite);
  @include sprite-position($sprite);
  @include sprite-width($sprite);
  @include sprite-height($sprite);
}

// The `sprites` mixin generates identical output to the CSS template
//   but can be overridden inside of SCSS
//
// @include sprites($spritesheet-sprites);
@mixin sprites($sprites) {
  @each $sprite in $sprites {
    $sprite-name: nth($sprite, 10);
    .#{$sprite-name} {
      @include sprite($sprite);
    }
  }
}
